#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>
#include <spu_mfcio.h>


#include "common.h"
#include "me_spu.h"
//#include "common/cpu.h"

#define MAXBUF 4096
#define MAXDMA 8192
#define SPU_THREADS 8

void spu_idle()
{
 spu_write_out_intr_mbox( 999 ); //Blocking call
 return;
}
  
//volatile spu_param_t spu_param ALIGN16;
volatile spu_param_t param_spu ALIGN16;
volatile int opcode ALIGN16;



int main(unsigned long long speid, unsigned long long argp, unsigned long long envp)
{    
  unsigned int ea;
  
  //printf("********** SPU START **********\n");
  
  while (1)
  {
  	spu_idle();

    ea = (unsigned int)spu_read_in_mbox();
	if (ea == 0)
		return (0);

    DMA_GET(&opcode,(unsigned int)ea,(sizeof(int)),0);
    DMA_WAIT(0);

	switch (opcode)
	{
		case 0x01:

			DMA_GET(&param_spu,(unsigned int)ea,(sizeof(spu_param_t)),0);
			DMA_WAIT(0);			
            
			x264_me_search_ref(param_spu.h, param_spu.m, param_spu.mvc, param_spu.i_mvc, param_spu.p_halfpel_thresh, param_spu.spes);

			break;
		case 0x02:
			break;
		default:
			break;
	}
  }
  
  return 0;
}

